﻿Option Strict Off
Imports System
Imports NXOpen
Imports NXOpen.UF
Imports NXOpenUI
Imports NXOpen.Utilities
Imports NXOpen.BlockStyler

Module Ellipsoid
    Dim s As Session = Session.GetSession()
    Dim ui As UI = ui.GetUI()
    Dim ufs As UFSession = UFSession.GetUFSession()
    Dim lw As ListingWindow = s.ListingWindow
    Sub Main()

        Try

            Dim MyEllipsoid = New ellipsoid1()
            ' The following method shows the dialog immediately
            MyEllipsoid.Show()

        Catch ex As Exception

            '---- Enter your exception handling code here -----
            ui.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        
        End Try



    End Sub



    Public Function GetUnloadOption(ByVal dummy As String) As Integer

        'Unloads the image immediately after execution within NX
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.Immediately

    End Function

    Public Class ellipsoid1
        'class members
        Private Shared theSession As Session
        Private Shared theUI As UI
        Public Shared theellipsoid1 As ellipsoid1
        Private theDialogName As String
        Private theDialog As NXOpen.BlockStyler.BlockDialog
        Private length As NXOpen.BlockStyler.UIBlock ' Block type: Double
        Private width As NXOpen.BlockStyler.UIBlock ' Block type: Double
        Private height As NXOpen.BlockStyler.UIBlock ' Block type: Double
        Private point0 As NXOpen.BlockStyler.UIBlock ' Block type: Specify Point
        '------------------------------------------------------------------------------
        'Bit Option for Property: SnapPointTypesEnabled
        '------------------------------------------------------------------------------
        Public Shared ReadOnly SnapPointTypesEnabled_UserDefined = 1
        Public Shared ReadOnly SnapPointTypesEnabled_Inferred = 2
        Public Shared ReadOnly SnapPointTypesEnabled_ScreenPosition = 4
        Public Shared ReadOnly SnapPointTypesEnabled_EndPoint = 8
        Public Shared ReadOnly SnapPointTypesEnabled_MidPoint = 16
        Public Shared ReadOnly SnapPointTypesEnabled_ControlPoint = 32
        Public Shared ReadOnly SnapPointTypesEnabled_Intersection = 64
        Public Shared ReadOnly SnapPointTypesEnabled_ArcCenter = 128
        Public Shared ReadOnly SnapPointTypesEnabled_QuadrantPoint = 256
        Public Shared ReadOnly SnapPointTypesEnabled_ExistingPoint = 512
        Public Shared ReadOnly SnapPointTypesEnabled_PointonCurve = 1024
        Public Shared ReadOnly SnapPointTypesEnabled_PointonSurface = 2048
        Public Shared ReadOnly SnapPointTypesEnabled_PointConstructor = 4096
        Public Shared ReadOnly SnapPointTypesEnabled_TwocurveIntersection = 8192
        Public Shared ReadOnly SnapPointTypesEnabled_TangentPoint = 16384
        Public Shared ReadOnly SnapPointTypesEnabled_Poles = 32768
        Public Shared ReadOnly SnapPointTypesEnabled_BoundedGridPoint = 65536
        '------------------------------------------------------------------------------
        'Bit Option for Property: SnapPointTypesOnByDefault
        '------------------------------------------------------------------------------
        Public Shared ReadOnly SnapPointTypesOnByDefault_UserDefined = 1
        Public Shared ReadOnly SnapPointTypesOnByDefault_Inferred = 2
        Public Shared ReadOnly SnapPointTypesOnByDefault_ScreenPosition = 4
        Public Shared ReadOnly SnapPointTypesOnByDefault_EndPoint = 8
        Public Shared ReadOnly SnapPointTypesOnByDefault_MidPoint = 16
        Public Shared ReadOnly SnapPointTypesOnByDefault_ControlPoint = 32
        Public Shared ReadOnly SnapPointTypesOnByDefault_Intersection = 64
        Public Shared ReadOnly SnapPointTypesOnByDefault_ArcCenter = 128
        Public Shared ReadOnly SnapPointTypesOnByDefault_QuadrantPoint = 256
        Public Shared ReadOnly SnapPointTypesOnByDefault_ExistingPoint = 512
        Public Shared ReadOnly SnapPointTypesOnByDefault_PointonCurve = 1024
        Public Shared ReadOnly SnapPointTypesOnByDefault_PointonSurface = 2048
        Public Shared ReadOnly SnapPointTypesOnByDefault_PointConstructor = 4096
        Public Shared ReadOnly SnapPointTypesOnByDefault_TwocurveIntersection = 8192
        Public Shared ReadOnly SnapPointTypesOnByDefault_TangentPoint = 16384
        Public Shared ReadOnly SnapPointTypesOnByDefault_Poles = 32768
        Public Shared ReadOnly SnapPointTypesOnByDefault_BoundedGridPoint = 65536

#Region "Block Styler Dialog Designer generator code"
        '------------------------------------------------------------------------------
        'Constructor for NX Styler class
        '------------------------------------------------------------------------------
        Public Sub New()
            Try

                theSession = Session.GetSession()
                theUI = UI.GetUI()
                theDialogName = "ellipsoid1.dlx"
                theDialog = theUI.CreateDialog(theDialogName)
                theDialog.AddApplyHandler(AddressOf apply_cb)
                theDialog.AddOkHandler(AddressOf ok_cb)
                theDialog.AddUpdateHandler(AddressOf update_cb)
                theDialog.AddInitializeHandler(AddressOf initialize_cb)
                theDialog.AddFocusNotifyHandler(AddressOf focusNotify_cb)
                theDialog.AddKeyboardFocusNotifyHandler(AddressOf keyboardFocusNotify_cb)
                theDialog.AddDialogShownHandler(AddressOf dialogShown_cb)

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                Throw ex
            End Try
        End Sub
#End Region

        '------------------------------------------------------------------------------
        Public Shared Function GetUnloadOption(ByVal arg As String) As Integer
            'Return CType(Session.LibraryUnloadOption.Explicitly, Integer)
            Return CType(Session.LibraryUnloadOption.Immediately, Integer)
            ' Return CType(Session.LibraryUnloadOption.AtTermination, Integer)
        End Function
        '------------------------------------------------------------------------------
        ' Following method cleanup any housekeeping chores that may be needed.
        ' This method is automatically called by NX.
        '------------------------------------------------------------------------------
        Public Shared Function UnloadLibrary(ByVal arg As String) As Integer
            Try

                Return 0

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            Return 0
        End Function

        '------------------------------------------------------------------------------
        'This method shows the dialog on the screen
        '------------------------------------------------------------------------------
        Public Sub Show()
            Try

                theDialog.Show()

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Method Name: Dispose
        '------------------------------------------------------------------------------
        Public Sub Dispose()
            If theDialog IsNot Nothing Then
                theDialog.Dispose()
                theDialog = Nothing
            End If
        End Sub

        '------------------------------------------------------------------------------
        '---------------------Block UI Styler Callback Functions--------------------------
        '------------------------------------------------------------------------------

        '------------------------------------------------------------------------------
        'Callback Name: initialize_cb
        '------------------------------------------------------------------------------
        Public Sub initialize_cb()
            Try

                length = CType(theDialog.TopBlock.FindBlock("length"), NXOpen.BlockStyler.UIBlock)
                width = CType(theDialog.TopBlock.FindBlock("width"), NXOpen.BlockStyler.UIBlock)
                height = CType(theDialog.TopBlock.FindBlock("height"), NXOpen.BlockStyler.UIBlock)
                point0 = CType(theDialog.TopBlock.FindBlock("point0"), NXOpen.BlockStyler.UIBlock)

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Callback Name: dialogShown_cb
        'This callback is executed just before the dialog launch. Thus any value set 
        'here will take precedence and dialog will be launched showing that value. 
        '------------------------------------------------------------------------------
        Public Sub dialogShown_cb()
            Try

                '---- Enter your callback code here -----

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Callback Name: apply_cb
        '------------------------------------------------------------------------------
        Public Function apply_cb() As Integer
            Dim errorCode As Integer = 0
            Try
                Dim centrePointProps As PropertyList = point0.GetProperties()
                Dim cpt As Point3d = centrePointProps.GetPoint("Point")
                centrePointProps.Dispose()
                centrePointProps = Nothing
                Dim wcstag As Tag = Tag.Null
                ufs.Csys.AskWcs(wcstag)
                Dim mattag As Tag = Tag.Null
                Dim wcsorigin(2) As Double
                ufs.Csys.AskCsysInfo(wcstag, mattag, wcsorigin)
                Dim matval(8) As Double
                ufs.Csys.AskMatrixValues(mattag, matval)
                Dim bsurfpppTag As Tag = Tag.Null
                Dim bsurfpnpTag As Tag = Tag.Null
                Dim bsurfnppTag As Tag = Tag.Null
                Dim bsurfnnpTag As Tag = Tag.Null
                Dim bsurfppnTag As Tag = Tag.Null
                Dim bsurfpnnTag As Tag = Tag.Null
                Dim bsurfnpnTag As Tag = Tag.Null
                Dim bsurfnnnTag As Tag = Tag.Null
                CreatePatchppp(cpt, matval, bsurfpppTag)
                CreatePatchpnp(cpt, matval, bsurfpnpTag)
                CreatePatchnpp(cpt, matval, bsurfnppTag)
                CreatePatchnnp(cpt, matval, bsurfnnpTag)
                CreatePatchppn(cpt, matval, bsurfppnTag)
                CreatePatchpnn(cpt, matval, bsurfpnnTag)
                CreatePatchnpn(cpt, matval, bsurfnpnTag)
                CreatePatchnnn(cpt, matval, bsurfnnnTag)

                CreateSewFeature(bsurfpppTag, bsurfpnpTag, bsurfnppTag, bsurfnnpTag, bsurfppnTag, bsurfpnnTag, bsurfnpnTag, bsurfnnnTag)

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                errorCode = 1
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            apply_cb = errorCode
        End Function

        '------------------------------------------------------------------------------
        'Callback Name: update_cb
        '------------------------------------------------------------------------------
        Public Function update_cb(ByVal block As NXOpen.BlockStyler.UIBlock) As Integer
            Try

                If block Is length Then
                    '---- Enter your code here -----

                ElseIf block Is width Then
                    '---- Enter your code here -----

                ElseIf block Is height Then
                    '---- Enter your code here -----

                ElseIf block Is point0 Then
                    '---- Enter your code here -----

                End If

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            update_cb = 0
        End Function

        '------------------------------------------------------------------------------
        'Callback Name: ok_cb
        '------------------------------------------------------------------------------
        Public Function ok_cb() As Integer
            Dim errorCode As Integer = 0
            Try

                '---- Enter your callback code here -----
                errorCode = apply_cb()

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                errorCode = 1
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
            ok_cb = errorCode
        End Function

        '------------------------------------------------------------------------------
        'Callback Name: focusNotify_cb
        'This callback is executed when any block (except the ones which receive keyboard entry such as Integer block) receives focus.
        '------------------------------------------------------------------------------
        Public Sub focusNotify_cb(ByVal block As BlockStyler.UIBlock, ByVal focus As Boolean)
            Try

                '---- Enter your callback code here -----

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        '------------------------------------------------------------------------------
        'Callback Name: keyboardFocusNotify_cb
        'This callback is executed when block which can receive keyboard entry, receives the focus.
        '------------------------------------------------------------------------------
        Public Sub keyboardFocusNotify_cb(ByVal block As BlockStyler.UIBlock, ByVal focus As Boolean)
            Try

                '---- Enter your callback code here -----

            Catch ex As Exception

                '---- Enter your exception handling code here -----
                theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
            End Try
        End Sub

        Public Sub CreatePatchppp(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfpppTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double

            Dim pole01 As Point3d = New Point3d(0.0, width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, width1 / 2.0, height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))

            Dim pole04 As Point3d = New Point3d(length1 / 2.0, width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(length1 / 2.0, width1 / 2.0, height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(length1 / 2.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))

            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfpppTag)

        End Sub

        Public Sub CreatePatchpnp(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfpnpTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, -width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, -width1 / 2.0, height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(length1 / 2.0, -width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(length1 / 2.0, -width1 / 2.0, height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(length1 / 2.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))

            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfpnpTag)
        End Sub

        Public Sub CreatePatchnpp(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfnppTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, width1 / 2.0, height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(-length1 / 2.0, width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(-length1 / 2.0, width1 / 2.0, height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(-length1 / 2.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(-length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))

            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfnppTag)
        End Sub

        Public Sub CreatePatchnnp(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfnnpTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, -width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, -width1 / 2.0, height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(-length1 / 2.0, -width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(-length1 / 2.0, -width1 / 2.0, height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(-length1 / 2.0, 0.0, height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(-length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfnnpTag)
        End Sub

        Public Sub CreatePatchppn(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfppnTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, width1 / 2.0, -height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(length1 / 2.0, width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(length1 / 2.0, width1 / 2.0, -height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(length1 / 2.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfppnTag)
        End Sub

        Public Sub CreatePatchpnn(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfpnnTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, -width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, -width1 / 2.0, -height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(length1 / 2.0, -width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(length1 / 2.0, -width1 / 2.0, -height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(length1 / 2.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfpnnTag)
        End Sub

        Public Sub CreatePatchnpn(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfnpnTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, width1 / 2.0, -height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(-length1 / 2.0, width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(-length1 / 2.0, width1 / 2.0, -height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(-length1 / 2.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(-length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfnpnTag)
        End Sub

        Public Sub CreatePatchnnn(ByVal cpt As Point3d, ByVal mt() As Double, ByRef bsurfnnnTag As Tag)
            Dim lengthProps As PropertyList = length.GetProperties
            Dim length1 As Double = lengthProps.GetDouble("Value")
            Dim widthProps As PropertyList = width.GetProperties
            Dim width1 As Double = widthProps.GetDouble("Value")
            Dim heightProps As PropertyList = height.GetProperties
            Dim height1 As Double = heightProps.GetDouble("Value")
            Dim pole0(2) As Double
            Dim pole01 As Point3d = New Point3d(0.0, -width1 / 2.0, 0.0)
            Dim pole02 As Point3d = New Point3d(0.0, -width1 / 2.0, -height1 / 2.0)
            Dim pole03 As Point3d = New Point3d(0.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole01.X * mt(0) + pole01.Y * mt(3) + pole01.Z * mt(6)
            pole0(1) = cpt.Y + pole01.X * mt(1) + pole01.Y * mt(4) + pole01.Z * mt(7)
            pole0(2) = cpt.Z + pole01.X * mt(2) + pole01.Y * mt(5) + pole01.Z * mt(8)
            Dim pole1 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole02.X * mt(0) + pole02.Y * mt(3) + pole02.Z * mt(6)
            pole0(1) = cpt.Y + pole02.X * mt(1) + pole02.Y * mt(4) + pole02.Z * mt(7)
            pole0(2) = cpt.Z + pole02.X * mt(2) + pole02.Y * mt(5) + pole02.Z * mt(8)
            Dim pole2 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole03.X * mt(0) + pole03.Y * mt(3) + pole03.Z * mt(6)
            pole0(1) = cpt.Y + pole03.X * mt(1) + pole03.Y * mt(4) + pole03.Z * mt(7)
            pole0(2) = cpt.Z + pole03.X * mt(2) + pole03.Y * mt(5) + pole03.Z * mt(8)
            Dim pole3 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole04 As Point3d = New Point3d(-length1 / 2.0, -width1 / 2.0, 0.0)
            Dim pole05 As Point3d = New Point3d(-length1 / 2.0, -width1 / 2.0, -height1 / 2.0)
            Dim pole06 As Point3d = New Point3d(-length1 / 2.0, 0.0, -height1 / 2.0)
            pole0(0) = cpt.X + pole04.X * mt(0) + pole04.Y * mt(3) + pole04.Z * mt(6)
            pole0(1) = cpt.Y + pole04.X * mt(1) + pole04.Y * mt(4) + pole04.Z * mt(7)
            pole0(2) = cpt.Z + pole04.X * mt(2) + pole04.Y * mt(5) + pole04.Z * mt(8)
            Dim pole4 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole05.X * mt(0) + pole05.Y * mt(3) + pole05.Z * mt(6)
            pole0(1) = cpt.Y + pole05.X * mt(1) + pole05.Y * mt(4) + pole05.Z * mt(7)
            pole0(2) = cpt.Z + pole05.X * mt(2) + pole05.Y * mt(5) + pole05.Z * mt(8)
            Dim pole5 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            pole0(0) = cpt.X + pole06.X * mt(0) + pole06.Y * mt(3) + pole06.Z * mt(6)
            pole0(1) = cpt.Y + pole06.X * mt(1) + pole06.Y * mt(4) + pole06.Z * mt(7)
            pole0(2) = cpt.Z + pole06.X * mt(2) + pole06.Y * mt(5) + pole06.Z * mt(8)
            Dim pole6 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            Dim pole07 As Point3d = New Point3d(-length1 / 2.0, 0.0, 0.0)
            pole0(0) = cpt.X + pole07.X * mt(0) + pole07.Y * mt(3) + pole07.Z * mt(6)
            pole0(1) = cpt.Y + pole07.X * mt(1) + pole07.Y * mt(4) + pole07.Z * mt(7)
            pole0(2) = cpt.Z + pole07.X * mt(2) + pole07.Y * mt(5) + pole07.Z * mt(8)
            Dim pole7 As Point3d = New Point3d(pole0(0), pole0(1), pole0(2))
            CreatePatch(pole1, pole2, pole3, pole4, pole5, pole6, pole7, bsurfnnnTag)
        End Sub

        Public Sub CreatePatch(ByVal pole1 As Point3d, ByVal pole2 As Point3d, ByVal pole3 As Point3d, _
                               ByVal pole4 As Point3d, ByVal pole5 As Point3d, ByVal pole6 As Point3d, _
                               ByVal pole7 As Point3d, ByRef bsurfTag As Tag)
            Dim w1 As Double = 1.0
            Dim w2 As Double = Math.Cos(Math.PI / 4.0)
            Dim w3 As Double = w2 * w2
            Dim uknot() As Double = {0.0, 0.0, 0.0, 1.0, 1.0, 1.0}
            Dim vknot() As Double = {0.0, 0.0, 0.0, 1.0, 1.0, 1.0}
            Dim pa(35) As Double

            pa(0) = pole1.X
            pa(1) = pole1.Y
            pa(2) = pole1.Z
            pa(3) = 1.0
            pa(4) = pole2.X * w2
            pa(5) = pole2.Y * w2
            pa(6) = pole2.Z * w2
            pa(7) = w2
            pa(8) = pole3.X
            pa(9) = pole3.Y
            pa(10) = pole3.Z
            pa(11) = 1.0

            pa(12) = pole4.X * w2
            pa(13) = pole4.Y * w2
            pa(14) = pole4.Z * w2
            pa(15) = w2
            pa(16) = pole5.X * w3
            pa(17) = pole5.Y * w3
            pa(18) = pole5.Z * w3
            pa(19) = w3
            pa(20) = pole6.X * w2
            pa(21) = pole6.Y * w2
            pa(22) = pole6.Z * w2
            pa(23) = w2

            pa(24) = pole7.X
            pa(25) = pole7.Y
            pa(26) = pole7.Z
            pa(27) = 1.0
            pa(28) = pole7.X * w2
            pa(29) = pole7.Y * w2
            pa(30) = pole7.Z * w2
            pa(31) = w2
            pa(32) = pole7.X
            pa(33) = pole7.Y
            pa(34) = pole7.Z
            pa(35) = 1.0

            Dim kfixup As Integer = Nothing
            Dim pfixup As Integer = Nothing

            ufs.Modl.CreateBsurf(3, 3, 3, 3, uknot, vknot, pa, bsurfTag, kfixup, pfixup)


        End Sub

        Public Sub CreateSewFeature(ByVal bsurfpppTag As Tag, ByVal bsurfpnpTag As Tag, _
                                     ByVal bsurfnppTag As Tag, ByVal bsurfnnpTag As Tag, _
                                     ByVal bsurfppnTag As Tag, ByVal bsurfpnnTag As Tag, _
                                     ByVal bsurfnpnTag As Tag, ByVal bsurfnnnTag As Tag)
            Dim wp As Part = s.Parts.Work
            Dim bodyppp As Body = NXObjectManager.Get(bsurfpppTag)
            Dim bodypnp As Body = NXObjectManager.Get(bsurfpnpTag)
            Dim bodynpp As Body = NXObjectManager.Get(bsurfnppTag)
            Dim bodynnp As Body = NXObjectManager.Get(bsurfnnpTag)
            Dim bodyppn As Body = NXObjectManager.Get(bsurfppnTag)
            Dim bodypnn As Body = NXObjectManager.Get(bsurfpnnTag)
            Dim bodynpn As Body = NXObjectManager.Get(bsurfnpnTag)
            Dim bodynnn As Body = NXObjectManager.Get(bsurfnnnTag)

            Dim nullFeatures_Feature As Features.Feature = Nothing
            Dim sewBuilder1 As Features.SewBuilder
            sewBuilder1 = wp.Features.CreateSewBuilder(nullFeatures_Feature)
            sewBuilder1.Tolerance = 0.0254
            Dim added1 As Boolean
            added1 = sewBuilder1.TargetBodies.Add(bodyppp)
            added1 = sewBuilder1.ToolBodies.Add(bodypnp)
            added1 = sewBuilder1.ToolBodies.Add(bodynpp)
            added1 = sewBuilder1.ToolBodies.Add(bodynnp)
            added1 = sewBuilder1.ToolBodies.Add(bodyppn)
            added1 = sewBuilder1.ToolBodies.Add(bodypnn)
            added1 = sewBuilder1.ToolBodies.Add(bodynpn)
            added1 = sewBuilder1.ToolBodies.Add(bodynnn)

            Dim nXObject1 As NXObject
            nXObject1 = sewBuilder1.Commit()
            sewBuilder1.Destroy()
        End Sub

    End Class

End Module
